>NAME ATKUIP

>MENU /Arte
>GUIDANCE
Program control.

>COMMAND RUN
>GUIDANCE
Start or continue event processing.
Examples:
 RUN
 RUN 1
 RUN 99999999
.
In batch jobs: RUN means RUN 99999999; no RUN command at all means
RUN 99999999.
.
In interactive jobs: RUN means RUN 1.
.
This command invokes the DD (Data Definition) program if a DDEFINITION
command (q.v.) has been stated before.
>ACTION KAEXEC
>PARAMETER
+
NEVENTS 'number of events' I D=0

>COMMAND Q
>GUIDANCE
Stop Arte.
QUIT or EXEC stop Arte unconditionally; Q gives you a chance to
resume program processing in case of mistyping which is quite likely
when using this help mechanism extensively.
>ACTION KAQUIT

>COMMAND GEAN
>GUIDANCE
Switch HERA-B detector simulation on / off.
The initial setting is GEAN OFF.
If neither ON nor OFF is given, ON is assumed.
>ACTION KAGEAN
>PARAMETER
+
SWITCH 'on/off' C D='on'

>COMMAND MIMP
>GUIDANCE
Switch impact point calculation in Geant on / off.
The initial setting is MIMP ON.
If neither ON nor OFF is given, ON is assumed.
>ACTION KAMIMP
>PARAMETER
+
SWITCH 'on/off' C D='on'

>COMMAND TIMELIMIT
>GUIDANCE
Estimated time for program termination.
Example:
 TIMELIMIT 5
Batch job stops event processing when less than 5 seconds are left.
>ACTION KATIME
>PARAMETER
+
TIME 'time in sec' R D=5.


************************************************************************
* End of ATKUIP
************************************************************************
