*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDATCP

************************************************************************
*
* Description: make include files *.hh from the DATT command
*
* OLD STYLE! New style: routine ddatcc
*
* Called from: DDEXEC
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, K4, K5, LENOCC, CHCMPN
      INTEGER IFF, IFH, IFB, IFU, IFC
      CHARACTER CC*200, CN*80, CA*80, CB*80, C27*27

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL CHCTOH ('F', IFF, 1)
      CALL CHCTOH ('H', IFH, 1)
      CALL CHCTOH ('B', IFB, 1)
      CALL CHCTOH ('U', IFU, 1)
      CALL CHCTOH ('C', IFC, 1)

C loop over tables

      DO 90 K1 = 1, NDDUSR
        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 90

C new deck *.hh

        CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CN)
        CALL DDOPEN (CN, 'hh')
        CALL DDNDEF (CN, 'HH')

C structure declarations for relations

        DO 10 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 20
          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 10

          CC = 'struct'
          CALL DDIREL (K2, K3)
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CA)
          CALL CHAPBC (CC, CA)
          CALL CHAPPC (CC, '_')
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CHAPPC (CC, CA)
          CALL DDCSTS (CC)

 10     CONTINUE

C declarations for attributes

 20     CC = 'struct'
        CALL CHAPBC (CC, CN)
        CALL CHAPBC (CC, '{')
        CALL DDCSTO (CC)

        DO 30 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 40

          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CUTOL (CA)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
            K5 = IDDEF_DIM(K2)
            CC = 'int'
            IF (HDDEF_NAM2(1,K2) .EQ. IFF)  THEN
              CC = 'float'
            ELSE IF (HDDEF_NAM2(1,K2) .EQ. IFH .OR. 
     +               HDDEF_NAM2(1,K2) .EQ. IFC)  THEN
              CC = 'char'
              K5 = 4 * MAX (K5, 1)
            ELSE IF (HDDEF_NAM2(1,K2) .EQ. IFB  .OR.
     +               HDDEF_NAM2(1,K2) .EQ. IFU)  THEN
              CC = 'unsigned'
            END IF

            CALL CHAPBC (CC, CA)

            IF (K5 .NE. 0)  THEN
              CALL CHAPPC (CC, '[')
              CALL CHAPPI (CC, K5)
              CALL CHAPPC (CC, ']')
            END IF

            CALL DDCSTS (CC)

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN

            CC = 'ArtePointer<'
            CALL DDIREL (K2, K3)
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CB)
            CALL CHAPPC (CC, CB)
            CALL CHAPPC (CC, '>')
            CALL CHAPBC (CC, CA)
            CALL DDCSTS (CC)

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            CC = 'ArteRelationPointer<'
            CALL DDIREL (K2, K3)
            CALL CHAPPC (CC, CN)
            CALL CHAPPC (CC, '_')
            CB = CA
            CALL CLTOU (CB)
            CALL CHAPPC (CC, CB)
            CALL CHAPPC (CC, '>')
            CALL CHAPBC (CC, CA)
            CALL DDCSTS (CC)

          END IF

 30       CONTINUE

 40     CONTINUE
        CALL DDCSTS ('}')

C include

        CC = '#include "auto/'

        DO 70 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 80
          IF (IDDEF_FLAG(K2) .LT. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 70

          CALL DDIREL (K2, K5)
          IF (K5 .EQ. K1)  THEN
            IF (IDDEF_FLAG(K2) .EQ. LDDEF_IN1 .OR.
     +          IDDEF_FLAG(K2) .EQ. LDDEF_INM)  GO TO 70
            GO TO 60
          END IF

          DO 50 K3 = K1 + 1, K2 - 1
            IF (IDDEF_FLAG(K3) .LT. LDDEF_RE1 .OR.
     +          IDDEF_FLAG(K3) .GT. LDDEF_INM)  GO TO 50
            CALL DDIREL (K3, K4)
            IF (K5 .EQ. K4)  GO TO 60
 50       CONTINUE

C #include table.hh

          CALL CHHTOC (IQ(HQDDEF_NAME(1,K5)), CA)
          CC(16:) = ' '
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '.hh"')
          CALL DDCSTO (CC)

C include relation.hh

 60       CALL CHHTOC (IQ(HQDDEF_NAM3(1,K2)), CA)
          CC(16:) = ' '
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '.hh"')
          CALL DDCSTO (CC)

 70     CONTINUE

C #include *.icc

 80     CC(16:) = ' '
        CALL CHAPPC (CC, CN)
        CALL CHAPPC (CC, '.icc"')
        CALL DDCSTO (CC)
        CALL DDCSTO ('#endif')

C deck *.icc

        CALL DDOPEN (CN, 'icc')
        CC = 'inline ArteLink & ArtePointer<'
        CALL CHAPPC (CC, CN)
        CALL CHAPPC (CC, '>::getLink()')
        CALL DDCSTO (CC)
        CC = '{ return artelink_.j'
        CA = CN
        CALL CUTOL (CA)
        CALL CHAPPC (CC, CA)
        CALL CHAPPC (CC, '; }')
        CALL DDCSTO (CC)

 90   CONTINUE

C loop over relations

      DO 130 K1 = 1, NDDNEW
        IF (IDDEF_FLAG(K1) .NE. LDDEF_REL)  GO TO 130
        CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CN)

C deck *.hh

        CALL DDOPEN (CN, 'hh')
        CALL DDNDEF (CN, 'HH')

        DO 110 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  K3 = K2
          IF (CHCMPN (IQ(HQDDEF_NAM3(1,K2)),
     +                IQ(HQDDEF_NAME(1,K1))) .EQ. 0)  GO TO 110
          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 110

          CC = 'struct'
          CALL DDIREL (K2, K4)
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CA)
          CALL CHAPBC (CC, CA)
          CALL CHAPPC (CC, '_')
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, ': public')
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K4)), CA)
          CALL CHAPBC (CC, CA)
          CALL CHAPBC (CC, '{}')
          CALL DDCSTS (CC)
 110    CONTINUE

        CC = '#include "auto/'
        CALL CHAPPC (CC, CN)
        CALL CHAPPC (CC, '.icc"')
        CALL DDCSTO (CC)
        CALL DDCSTO ('#endif')

C deck *.icc

        CALL DDOPEN (CN, 'icc')

        DO 120 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  K3 = K2
          IF (CHCMPN (IQ(HQDDEF_NAM3(1,K2)),
     +                IQ(HQDDEF_NAME(1,K1))) .EQ. 0)  GO TO 120

          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 120

          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 120

          CC = 'inline ArteLink & ArtePointer<'
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CA)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '_')
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '>::getLink()')
          CALL DDCSTO (CC)

          CC = '{ return artelink_.j'
          CALL CUTOL (CN)
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, '; }')
          CALL DDCSTO (CC)

          CC = 'inline int ArteRelationPointer<'
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CA)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '_')
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '>::relType()')
          CALL DDCSTO (CC)
          K5 = 2
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM)  K5 = 4
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN
            CALL DDIREL (K2, K4)
            CALL DDRTYP (K2, K4)
            IF (K4 .EQ. 4)  K5 = 3
          END IF
          CC = '{ return'
          CALL CHAPBI (CC, K5)
          CALL CHAPPC (CC, '; }')
          CALL DDCSTO (CC)

 120    CONTINUE

 130  CONTINUE

      END

************************************************************************
* End of DDATCP
************************************************************************
