*-- Author :    Hartwig Albrecht   01/12/95

      SUBROUTINE TPRELA

************************************************************************
*
* Description: maintain the relation from TOPP to TDEC
*
* Called from: MMREAD
*
* External references: none
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"
#include "auto/TDEC.fi"

      INTEGER I, J, L

#include "arte/Arte.ff"
#include "auto/TOPP.ff"
#include "auto/TDEC.ff"

      IF (JTDEC .EQ. 0 .OR. JTOPP .EQ. 0)  GO TO 90

      DO I = 1, NTOPP()
        IQ(IQTOPP_TDEC(I)) = 0
      END DO

      DO I = 1, NTDEC()
        IQ(IQTDEC_NEXT(I)) = 0
      END DO

      DO 30 I = 1, NTDEC()
        IQ(IQTDEC_NEXT(I)) = 0
        J = ITDEC_MOTH(I)
        IF (J .EQ. 0)  GO TO 30
        L = ITOPP_TDEC(J)
        IF (L .EQ. 0)  THEN
          IQ(IQTOPP_TDEC(J)) = I
          GO TO 30
        END IF

C keep the original order of DECAY statements

 10     IF (ITDEC_NEXT(L) .EQ. 0)  GO TO 20
        L = ITDEC_NEXT(L)
        GO TO 10
 20     IQ(IQTDEC_NEXT(L)) = I

 30   CONTINUE

 90   END

************************************************************************
* End of TPRELA
************************************************************************
