#ifndef _GWAL_HH_
#define _GWAL_HH_
struct GWAL {
   int shp;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float rot[9];
   float ms;
   int nsl;
   ArtePointer<GESL> gesl;
   ArtePointer<GMAT> gmat;
   int gede;
   char gvol[4];
   float dedx;
};
#include "auto/GESL.hh"
#include "auto/GSGW.hh"
#include "auto/GMAT.hh"
#include "auto/GMGW.hh"
#include "auto/GWAL.icc"
#endif
