#ifndef _MTRA_H_
#define _MTRA_H_
typedef struct {
   float px;
   float py;
   float pz;
   float ml;
   int flag;
   int otopp;
   int orig;
   float mass;
   float leng;
   int obver;
   int obtra;
   int petra;
   int pever;
   int pmimp;
   int pmcal;
   int prtra;
   int prseg;
   int prccl;
   int omtcp;
} MTRA;
#define  JMTRA (gcbank_.iq+artelink_.jmtra)
#define  NMTRA() N_U(JMTRA)
#define NCMTRA() N_C(JMTRA)
#define MTRA(i) (*((MTRA*)(JMTRA+2)+(i)-1))
#define MTRA_otopp(i) MTRA(i).otopp
#define MTRA_obver(i) MTRA(i).obver
#define MTRA_obtra(i) MTRA(i).obtra
#include "auto/MTMT.h"
#define MTRA_petra(i) MTRA(i).petra
#define MTRA_metra(i) M_R(i,JMTMT)
#define MTRA_xetra(i) X_R(i,JMTMT)
#include "auto/MTMV.h"
#define MTRA_pever(i) MTRA(i).pever
#define MTRA_mever(i) M_R(i,JMTMV)
#define MTRA_xever(i) X_R(i,JMTMV)
#include "auto/MTMI.h"
#define MTRA_pmimp(i) MTRA(i).pmimp
#define MTRA_mmimp(i) M_R(i,JMTMI)
#define MTRA_xmimp(i) X_R(i,JMTMI)
#include "auto/MTMC.h"
#define MTRA_pmcal(i) MTRA(i).pmcal
#define MTRA_mmcal(i) M_R(i,JMTMC)
#define MTRA_xmcal(i) X_R(i,JMTMC)
#include "auto/RTMT.h"
#define MTRA_prtra(i) MTRA(i).prtra
#define MTRA_mrtra(i) M_1(i,JRTMT)
#define MTRA_xrtra(i) X_1(i,JRTMT)
#include "auto/RSMT.h"
#define MTRA_prseg(i) MTRA(i).prseg
#define MTRA_mrseg(i) M_1(i,JRSMT)
#define MTRA_xrseg(i) X_1(i,JRSMT)
#include "auto/MTRC.h"
#define MTRA_prccl(i) MTRA(i).prccl
#define MTRA_mrccl(i) M_2(i,JMTRC)
#define MTRA_xrccl(i) X_2(i,JMTRC)
#define MTRA_omtcp(i) MTRA(i).omtcp
#endif
