#ifndef _TOPP_HH_
#define _TOPP_HH_
struct TOPP_MTRA;
struct TOPP_RTRA;
struct TOPP {
   char name[12];
   float mass;
   float wid;
   float trbw;
   float life;
   int chrg;
   int colo;
   int deca;
   int lund;
   int gean;
   int anti;
   int tdec;
   ArteRelationPointer<TOPP_MTRA> mtra;
   ArteRelationPointer<TOPP_RTRA> rtra;
};
#include "auto/MTRA.hh"
#include "auto/MTTO.hh"
#include "auto/RTRA.hh"
#include "auto/RTTO.hh"
#include "auto/TOPP.icc"
#endif
