*-- Author :
      SUBROUTINE PICITR
C----------------------

C   To draw a view of one MT superlayer or its components

      IMPLICIT NONE
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/MVOLUM.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

      CHARACTER*4 MTDA(3),NAME(4),PERS,NAM
      INTEGER ICOL(8),IFPL,J,K,NUME(4),ISL,LAY,SEC,ISEC,IUCOMP
      REAL X(2), Y(2)
      DATA ICOL /4,4,2,2,4,4,2,2/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
C
      CALL KUGETC(PERS,J)
      CALL KUGETC(NAM,J)
      ISL = IUCOMP(NAM,DEMT,NSLMT)
      IF(ISL.EQ.0) THEN
         PRINT *,'Superlayer ',NAM,' is not a MSGC'
         GO TO 999
      ENDIF
      NAME(1) = NAM
      NUME(1) = 1

      DO J=1,IQ(JNESL+2)
      IF(INESL_CMP(J).EQ.LGESL_MSG) THEN
         IF(INESL_NSL(J).EQ.ISL) GO TO 10
      ENDIF
      ENDDO
      PRINT *,'SUPERLAYER ',ISL,' OF COMPONENT ',LGESL_MSG,' NOT FOUND'
      GO TO 999

 10   IF(INESL_MFL(J).NE.0) THEN
         MTDA(1) = 'MTLM'
         MTDA(2) = 'MTEM'
         MTDA(3) = 'MTG2'
      ELSE
         MTDA(1) = 'MTLY'
         MTDA(2) = 'MTEL'
         MTDA(3) = 'MTG1'
      ENDIF

      CALL GSATT(DEMT(ISL),'SEEN',0)
      CALL GSATT('MTWA','SEEN',0)

      CALL GSATT(MTDA(1),'COLO',1)
      CALL GSATT(MTDA(1),'FILL',1)
      CALL GSATT(MTDA(2),'COLO',2)
      CALL GSATT(MTDA(2),'FILL',1)
      CALL GSATT(MTDA(3),'COLO',3)
      CALL GSATT(MTDA(3),'FILL',1)

      CALL GDOPT('HIDE','OFF ')
      CALL GDOPT('SHAD','ON ')

      CALL KUGETI(LAY)
      CALL KUGETI(SEC)

      IFPL =INESL_FPL(J)

      do 20 k=1,INESL_NPL(J)
      IF(INEDE_LAY(IFPL+K-1).NE.LAY) GO TO 20
      ISEC = INEDE_SEC(IFPL+K-1)
      IF(SEC.NE.0 .AND. ISEC.NE.SEC) GO TO 20
      NAME(2) = MTDA(1)
      NUME(2) = IFPL + K - 1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,10.,10.,.25,.25)
      NAME(2) = MTDA(2)
      IF(SEC.NE.0) THEN
         IF(ISEC.EQ.1.OR.ISEC.EQ.3..OR.ISEC.EQ.5.OR.ISEC.EQ.7)
     +                                     NUME(2) = NUME(2)+1
      ELSE
         IF(ISEC.EQ.1.OR.ISEC.EQ.3..OR.ISEC.EQ.5.OR.ISEC.EQ.7)
     +                                                GO TO 15
      ENDIF
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,10.,10.,.25,.25)

 15   NAME(2) = MTDA(3)
      NUME(2) = 4*(IFPL + K - 1) -3
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,10.,10.,.25,.25)
      NUME(2) = 4*(IFPL + K - 1) -2
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,10.,10.,.25,.25)
      NUME(2) = 4*(IFPL + K - 1) -1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,10.,10.,.25,.25)
      IF(ISEC.EQ.2.OR.ISEC.EQ.4.OR.ISEC.EQ.5.OR.ISEC.EQ.7) THEN
         NUME(2) = 4*(IFPL + K - 1)
         CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,10.,10.,.25,.25)
      ENDIF
 20   CONTINUE

      call gdcol(1)
      x(1) = 5.
      y(1) = 5.
      x(2) = 15.
      y(2) = 13.
c      CALL GDRAWV(x,y,2)

      CALL GDSCAL(10.,2.)
      CALL GDHEAD(1001,'HERA-B  MT-Superlayer',.6)

 999  RETURN
      END
