*-- Author :    Rainer Mankel   13/01/97

      subroutine prrpnt()

*     **** print reconstructed points table
*     **** called by KUIP

      implicit none
#include "arte/Arte.fi"
      integer rp, rp1, rp2, rt, rs, iirp, indrp, nch
      real p_rc
      character*1 cresp
      character*40 chopt
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"

*     **** number of selected track
      call kugeti(rp1)
      call kugeti(rp2)
      call kugeti(rt)
      call kugeti(rs)
      call kugetc(chopt,nch)

*     **** fixup
      if (jrpnt.le.0) then
         call mewarn('prrpnt: table RPNT is not booked')
         go to 999
      endif

      if (rt.eq.0.and.rs.eq.0) then
         if (rp2.eq.0) rp2 = rp1
         if (rp1.eq.0) then
            rp1 = 1
            rp2 = iq(jrpnt+2)
         endif
         rp1 = max(1,rp1)
         rp2 = min(rp2,iq(jrpnt+2))
         call prxrpnt(rp1,rp2,' ',chopt)
      else
         if (rt.gt.0) then
            if (jrtra.le.0) then
               call mewarn('prrpnt: table RTRA is not booked')
               go to 999
            endif
            
            do 10 iirp=1,999
               if (iirp.eq.1) then
                  indrp = prtra_rpnt(rt)
               else
                  indrp = xrtra_rpnt(indrp)
               endif
               if (indrp.eq.0) go to 11
               rp = mrtra_rpnt(indrp)
               call prxrpnt(rp,rp,' ',chopt)
 10         continue
 11         continue
         endif

         if (rs.gt.0) then
            if (jrseg.le.0) then
               call mewarn('prrpnt: table RSEG is not booked')
               go to 999
            endif
            
            do 20 iirp=1,999
               if (iirp.eq.1) then
                  indrp = prseg_rpnt(rs)
               else
                  indrp = xrseg_rpnt(indrp)
               endif
               if (indrp.eq.0) go to 21
               rp = mrseg_rpnt(indrp)
               call prxrpnt(rp,rp,' ',chopt)
 20         continue
 21         continue
         endif
      endif

 999  end
