*     Author:  Vitaly Eiges,  22.03.99
*     Decodes the hits corresponding to pad plane
*     and calls hitb filling procedure

      SUBROUTINE MDFILLP (iPLANE, th1, th2, npmx)

C     Fills HITB for pad planes iPLANE, iPLANE+1
C     Hit vectors th1(32), th2(32)
      
      IMPLICIT NONE
      
#include "arte/Arte.fi"
#include "auto/GEDE.fi"

      integer iPLANE, npmx, th1(32), th2(32)
      integer iPAD
      
#include "arte/Arte.ff"
#include "auto/GEDE.ff"
      
C     filling HITB for low Z
      
      do iPAD = 1 , 15
         if (th1(iPAD+1).eq.1) then
            call mdbookp( iPLANE, iPAD, 2)
         endif
         if (th2(iPAD+1).eq.1) then
            call mdbookp( iPLANE, iPAD, 1)
         endif
      enddo       
      
      do iPAD = 16 , npmx
         if (th1(iPAD+2).eq.1) then
            call mdbookp( iPLANE, iPAD, 2)
         endif
         if (th2(iPAD+2).eq.1) then
            call mdbookp( iPLANE, iPAD, 1)
         endif
      enddo
      
C     filling HITB for large Z

C     If wanna 1 pad hit per pair - dont comment next line
C     Note that some artifical X & Z shifts were introduced 
C     in the low Z layer
      
      goto 900 
      
      do iPAD = 1 , 15
         if (th1(iPAD+1).eq.1) then
            call mdbookp( iPLANE+1, iPAD, 2)  
         endif
         if (th2(iPAD+1).eq.1) then
            call mdbookp( iPLANE+1, iPAD, 1) 
         endif
      enddo
      
      do iPAD = 16 , npmx
         if (th1(iPAD+2).eq.1) then
            call mdbookp( iPLANE+1, iPAD, 2)  
         endif
         if (th2(iPAD+2).eq.1) then
            call mdbookp( iPLANE+1, iPAD, 1) 
         endif
      enddo
      
 900  END
