* Authors :    Vitaly Eiges   22.03.99
* Sorting of muon hits to get sequential sets for each plane
* Called at the end of MD2HITB.C 

      SUBROUTINE MDSORT (n1, n2)

         IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"

         integer i, j
         integer n1, n2   !  first and last muon hits
 
#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"

         if (n1.lt.0) goto 900
         if (n2.le.0) goto 900

C        Hits are being sorted

         do i = n1 , n2 - 1
            do j = i + 1, n2
               if (ihitb_gede(i).eq.ihitb_gede(j)) call mdexch(i+1,j)
            enddo
         enddo

C        Set HIT1-HITL info

         iq(iqgede_hit1(ihitb_gede(n1))) = n1
         iq(iqgede_hitl(ihitb_gede(n1))) = n1

         do i = n1+1, n2
            iq(iqgede_hitl(ihitb_gede(i))) = i
            if (ihitb_gede(i).ne.ihitb_gede(i-1)) 
     &           iq(iqgede_hit1(ihitb_gede(i))) = i
         enddo
         
 900     END
      
      SUBROUTINE MDEXCH(i,j)

         IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"

         integer i, j, gede
         real x, y, z, rq, rr
         
#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"

         x = fhitb_x(i)
         y = fhitb_y(i)
         z = fhitb_z(i)
         rq = fhitb_q(i)
         rr = fhitb_r(i)
         gede = ihitb_gede(i)
         
         q(qhitb_x(i)) = fhitb_x(j)
         q(qhitb_y(i)) = fhitb_y(j)
         q(qhitb_z(i)) = fhitb_z(j)
         q(qhitb_q(i)) = fhitb_q(j)
         q(qhitb_r(i)) = fhitb_r(j)
        iq(iqhitb_gede(i)) = ihitb_gede(j)

         q(qhitb_x(j)) = x
         q(qhitb_y(j)) = y
         q(qhitb_z(j)) = z
         q(qhitb_q(j)) = rq
         q(qhitb_r(j)) = rr
        iq(iqhitb_gede(j)) = gede

        end

               
