*-- Author :    Rainer Mankel   08/11/93

      subroutine dirseg(imc,idrc,islsta,islend,chopt)

*     **** display all reconstructed segments
      implicit none
#include "pris/zgraf.fi"
#include "pris/zmh.fi"
#include "arte/Arte.fi"

      integer rs, imc, idrc, islsta, islend, ialia, indx_rseg, 
     +     indx_mtra, mc_match
      character*(*) chopt
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/MTRA.fi"
#include "arte/RSEG_cmp.fi"

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
#include "auto/MTRA.ff"

      if (jrseg.le.0) then
         call mewarn('dirseg: table RSEG is not booked')
         go to 999
      endif



      if (imc.eq.0) then
         do 10 rs=1,iq(jrseg+2) ! loop over RSEGs
*           **** skip RICH segment (will be displayed in diring)
            if (irseg_cmp(rs).eq.rsegc_rich) go to 10
*           **** skip killed segments
            if (iand(irseg_cmp(rs),rsegc_bitsign).ne.0) go to 10
*           **** locate mc_match
            if (prseg_mtra(rs).gt.0) then
               indx_mtra = prseg_mtra(rs)
               if (indx_mtra.gt.0) then
                  mc_match = mrseg_mtra(indx_mtra)
               else
                  mc_match = 0
               endif
            else
               mc_match = 0
            endif

*           **** check imc
            if (imc.ne.0.and.mc_match.ne.imc) go to 10
*           **** check idrc
**            if (idrc.ne.0.and.orseg_rtra(rs).ne.idrc) go to 10
*           **** check -B
            if (lb0zg.or.index(chopt,'B').gt.0) then
               if (mc_match.eq.0) go to 10
               if (.not.gold_mh(mc_match)) go to 10
            endif

*           **** check ref option
            if (index(chopt,'R').gt.0) then
               if (mc_match.eq.0) go to 10
               if (.not.ref_mh(mc_match)) go to 10
            endif

            call di1rseg(rs,islsta,islend,chopt)
 10      continue
      else
*        **** find RC tracks associated with imc
         if (jmtra.le.0) go to 999
         if (imc.lt.0.or.imc.gt.iq(jmtra+2)) then
            print *,' () dirseg: invalid imc=', imc
            go to 999
         endif

         do 20 ialia=1,20
            if (ialia.eq.1) then
               indx_rseg = pmtra_rseg(imc)
            else
               indx_rseg = xmtra_rseg(indx_rseg)
            endif
            if (indx_rseg.eq.0) go to 21

            rs = mmtra_rseg(indx_rseg)
            call di1rtra(rs,islsta,islend,chopt)
 20      continue
 21      continue
      endif

 999  end

