*CMZ :  4.03/00 21/07/96  20.00.51  by  Rainer Mankel
*-- Author :    Rainer Mankel   21/07/96

      integer function dm96sec(pl)

*     **** fix sector numbers for 96 run
      implicit none


*      ---------------------------
*      |              |          |
*      |              |          |
*      |              |     1    |
*      |              |          |
*      |      5       |----------|
*      |              |          |
*      |              |     2    |
*      |              |          |
*      |              |          |
*      |--------------|----------|
*      |              |          |
*      |              |          |
*      |              |     3    |
*      |              |          |
*      |      6       |----------|
*      |              |          |
*      |              |          |
*      |              |     4    |
*      |              |          |
*      ---------------------------


      integer pl,dm_sec
      real xmean,ymean

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      dm_sec = 8

      if (igede_cmp(pl).eq.1) then
         dm_sec = 7
      elseif (igede_cmp(pl).eq.2) then
         xmean = 0.5*(fgede_xmin(pl)+fgede_xmax(pl))
         ymean = 0.5*(fgede_ymin(pl)+fgede_ymax(pl))
         if (xmean.gt.0..or.xmean.lt.-85.) then
            print *,' () dm96sec: invalid xmean=',xmean,
     +           ' for pl,sl,cmp=',pl,ogede_gesl(pl),igede_cmp(pl)
         elseif (xmean.gt.-45.) then
            if (ymean.gt.50..or.ymean.lt.-50.) then
               print *,' () dm96sec: invalid ymean=',ymean,
     +              ' for pl,sl,cmp=',pl,ogede_gesl(pl),igede_cmp(pl)
            elseif (ymean.gt.15.) then
               dm_sec = 1
            elseif (ymean.gt.0.) then
               dm_sec = 2
            elseif (ymean.gt.-15.) then
               dm_sec = 3
            else
               dm_sec = 4
            endif
         else
            if (ymean.gt.0.) then
               dm_sec = 5
            else
               dm_sec = 6
            endif
         endif
**            print '((a),3i6,2f12.3,i4)',
**     +           'pl,sl,sec,xmean,ymean,dm96sec=',
**     +           pl,ogede_gesl(pl),igede_sec(pl),
**     +           0.5*(fgede_xmin(pl)+fgede_xmax(pl)),
**     +           0.5*(fgede_ymin(pl)+fgede_ymax(pl)),dm_sec
      else
**            print *,' () dm96sec: pl,sl,cmp=',pl,ogede_gesl(pl),
**     +           igede_cmp(pl)
      endif

      dm96sec = dm_sec

      end






