*CMZ :  4.02/00 30/05/96  19.38.54  by  Rainer Mankel
*-- Author :    Rainer Mankel   30/05/96

      real function tfxseg(z,dom)

*     **** extrapolate z coordinate from saved x candidate
      implicit none
#include "rang/zdomain.fi"
      integer dom,dlx
      real dz,z

      if (dom.gt.dom0_dlx.and.dom.le.dom2_dlx) then
         dlx = dom - dom0_dlx
         if (dlx.lt.dlx1_dlx) dlx = dlx1_dlx
         if (dlx.gt.dlx2_dlx) dlx = dlx2_dlx
         dz  = z - z_dlx(dlx)
         if (abs(dz).gt.30.) then
            print *,' () tfxseg: dz=', dz
         endif
         tfxseg = x_dlx(dlx) + dz * tx_dlx(dlx)
      else
         print *,' () tfxseg: domain unavailable, dom=', dom
         tfxseg = 0.
         stop 'tfxseg'
      endif

      if (tfxseg.gt.-1000..and.tfxseg.lt.1000.) then
      else
         print *,' () tfxseg: funny value ', tfxseg
      endif

      end
