#include  <stdio.h>

#include "silarte/silarte.hh"

#include "aframelib.h"
#include "silraw.h"
#include "marvin.h"

#include "grr.h"
#include "event.h"

// record ID from SvdEvnt
extern int DSVDrecid;

//----------------------------------------------------------------------------
//
//  Terminate all SVD code.
//  Note that we don't have to terminate aframe-related stuff.
//
//----------------------------------------------------------------------------
int SvdStop()
{
  // terminate silraw
  silraw_endrun();

  // terminate marvin (call marvin_endrun only when marvin really ran)
  // The record ID should still be there from the last event
  if ( DSVDrecid == RID_NORMAL_SLB0)
    marvin_endrun();

  return GRR_OK;
}




