/*================================================================== 
   Author : Dmitri Bandourin

    created: March 1999

    Purpose: 
    The subroutine finds time and date of next Leda table  
====================================================================*/

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "ledaC++.hh"

#define EXT3 
#include "alca/TDnext.h"

extern "C"{
#include "alca/GlobAl.h"

int acGlobAlNext( char* dbName, int TimeEvt, int DateEvt)
 {

  static FILE *fp = fopen("Gl_next","w");

  MizziDatabase mydb;
  Tables x;
  x = mydb.open(dbName,0);
  fprintf(fp,"\n\n GlobAlNext: TimeEvt %d DateEvt %d",TimeEvt,DateEvt);
  GLOBAL_ALGN_TEST->initialize(); 
  LedaCheckDD();

  GLOBAL_ALGN_TEST -> book( mydb );
  mydb.stamp(DateEvt,TimeEvt);               
  int xe = GLOBAL_ALGN_TEST -> fetch_data( DBgt );
 
  if( !xe) 
    {
      fprintf(fp,"\n GlobAlNext: No next table");
      GLOBAL_ALGN_TEST -> remove -> all();
      GLOBAL_ALGN_TEST -> unbook();
      mydb.close();
      return -1;
    }

  GLOBAL_ALGN_TEST -> set_keys();

  TDnext.DateNext = TableMajor(x);
  TDnext.TimeNext = TableMinor(x);
  fprintf(fp,"\n GlobAlNext: next table exists for Tnext %d Dnext %d",
              TDnext.TimeNext,TDnext.DateNext);
 
  GLOBAL_ALGN_TEST -> remove -> all();
  GLOBAL_ALGN_TEST -> unbook();
  mydb.close();
 
  return 1;

 }
}
