#ifndef _RSEG_cmp_h_
#define _RSEG_cmp_h_

#define RSEGC_VXD     (         1l) /* Vertex Detector */
#define RSEGC_PATT    (         2l) /* Pattern Tracker*/
#define RSEGC_MAGT    (         4l) /* Magnet Tracker*/
#define RSEGC_MUON    (         8l) /* Muon Detector*/
#define RSEGC_ECAL    (        16l) /* Ecal*/
#define RSEGC_TAR     (        32l) /* Target Constraint*/

#define RSEGC_BIT6    (        64l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT7    (       128l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT8    (       256l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT9    (       512l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT10   (      1024l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT11   (      2048l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT12   (      4096l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT13   (      8192l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT14   (     16384l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT15   (     32768l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT16   (     65536l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT17   (    131072l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT18   (    262144l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT19   (    524288l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT20   (   1048576l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT21   (   2097152l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT22   (   4194304l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT23   (   8388608l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT24   (  16777216l) /* not assigned yet (first bit is bit0)*/

#define RSEGC_TRD     (  33554432l) /* forward TRD*/
#define RSEGC_RICH    (  67108864l) /* Cherenkov Counter*/
#define RSEGC_PTC     ( 134217728l) /* PTC Chambers (pi-pi trigger)*/
#define RSEGC_MSG     ( 268435456l) /* microstrip chambers*/
#define RSEGC_WCH     ( 536870912l) /* wire chambers*/
#define RSEGC_SIL     (1073741824l) /* silicon detector*/
#define RSEGC_BITSIGN (-2147483648l) /* Do not use sign bit to avoid complications*/
#endif
































