#ifndef _GESL_HH_
#define _GESL_HH_
struct GESL_GEDE;
struct GESL_GCAL;
struct GESL_GWAL;
struct GESL {
   char name[4];
   int cmp;
   int shp;
   int nsl;
   int mfl;
   int lay;
   float x1;
   float x2;
   float y1;
   float y2;
   float z1;
   float z2;
   float dx;
   float dy;
   int npl;
   int fpl;
   int nwl;
   int fwl;
   int ltyp;
   ArteRelationPointer<GESL_GEDE> gede;
   ArteRelationPointer<GESL_GCAL> gcal;
   ArteRelationPointer<GESL_GWAL> gwal;
};
#include "auto/GEDE.hh"
#include "auto/GSGD.hh"
#include "auto/GCAL.hh"
#include "auto/GSGC.hh"
#include "auto/GWAL.hh"
#include "auto/GSGW.hh"
#include "auto/GESL.icc"
#endif
