#ifndef _NEDE_H_
#define _NEDE_H_
typedef struct {
   int cmp;
   int lay;
   int sec;
   int shp;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float sxmn;
   float sxmx;
   float symn;
   float symx;
   float cos;
   float sin;
   float rot[9];
   float acc;
   float eff;
   float dod;
   float pit;
   float ms;
   float xfw[4];
   float zfw[4];
   int nwi[4];
   int nsl;
   int onesl;
   int ogmat;
   int nwl;
   int fwl;
   float xmad;
   float ymad;
   float zmad;
   float y1w[4];
   float y2w[4];
   char gvol[4];
   char hwc[12];
   float dedx;
   int gcop;
} NEDE;
#define  JNEDE (gcbank_.iq+artelink_.jnede)
#define  NNEDE() N_U(JNEDE)
#define NCNEDE() N_C(JNEDE)
#define NEDE(i) (*((NEDE*)(JNEDE+2)+(i)-1))
#define NEDE_onesl(i) NEDE(i).onesl
#define NEDE_ogmat(i) NEDE(i).ogmat
#endif
