/************************************************************************
*
* cr_HepRot
* written by Siegmund Nowak, January 98
*
* class cr_HepRot contains CLHEP functions HepRot adapted to GEDE  
* Rotation tables (for use in digi) 
*
*       called from everywhere
*
************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "digi/cr_HepRot.hh"
#include "arte/Arte.hh"
#include "arte/ArteUtil.h"
#include "arte/ArteMessage.hh"
#include "auto/GEO.hh"

void cr_HepRot::set_HepRot(int ipl) {
      ArtePointer<GEDE> gede(ipl);
      rxx = gede->rot[0];
      rxy = gede->rot[3];
      rxz = gede->rot[6];
      ryx = gede->rot[1];
      ryy = gede->rot[4];
      ryz = gede->rot[7];
      rzx = gede->rot[2];
      rzy = gede->rot[5];
      rzz = gede->rot[8]; }

void cr_HepRot::rotate_Z(float pold[], float pnew[]) {  
      pnew[0] = rxx*pold[0] + rxy*pold[1];
      pnew[1] = ryx*pold[0] + ryy*pold[1];
      pnew[2] = pold[2];}
