#ifndef _ZGCAL_HH_
#define _ZGCAL_HH_

  typedef struct {
    int   ncalx, ncaly; 
    float cal_xmin, cal_xmax, cal_ymin, cal_ymax;
    float caba_size;
    float zcal[3];
    float zwall[6];
    float dzwall[6];
    char  * pt_castru;
  } hgcal;

class zgcal {
public:
 
  zgcal() {}
  ~zgcal() {} 
  
  static void ini(const int n);
  static void fin();
  static void increase();
  void Set_default();
  void Read_calsubgroup();     
  void Read_ncal(char*);     
  void Read_poscal(char*);
  void Read_caba_size(char*);     
  void Read_zcal(char*);     
  void Read_zcwall(char*);     
  void Read_dzwall(char*);     
  void Read_cast(char*,FILE *filepointer);
};
#endif











