*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE KADTA1 (IFLAG)

************************************************************************
*
* Description: DTABLE, DRELAT, DMENU command
*
* Called from: KADTAB, KADREL, KADMEN
*
* External references: KADINI
*
* Arguments: in/out description
*   IFLAG    in     1: KADTAB; 2: KADREL; 3: KADMEN
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER L, IFLAG
      CHARACTER CN*80

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL KADZZI (IFLAG)

      CALL KADZZN

      IF (IFLAG .EQ. LDDEF_TAB)  CALL KUGETI (IQ(IQDDEF_DIM_L()))

      IF (IFLAG .LE. LDDEF_REL)  THEN
        CN = ' '
        CALL KUGETC (CN, L)
        IF (CN(1:1) .EQ. 'C')  THEN
          IQ(L_L(JDDEF_DIV,JDDEF)) = 1
        ELSE IF (CN(1:1) .EQ. 'E')  THEN
          IQ(L_L(JDDEF_DIV,JDDEF)) = 2
        ELSE
        CALL LIDDE0 (NDDEF(), 'TL')
          CALL MEERRC (836541, 'DD: Zebra division must be C or E')
        END IF
      END IF

      CALL KADZZC

      CN = ' '
      CALL KUGETC (CN, L)
      CALL CHCTOH (CN, IQ(L_L(JDDEF_NAM2,JDDEF)), NAMELEN)
      IF (L .GT. 80)  THEN
        CALL LIDDE0 (NDDEF(), 'TL')
        CALL MEERRC (675765,
     +  'DD: names must consist of not more than 80 characters')
      END IF

      END

************************************************************************
* End of KADTA1
************************************************************************
