>NAME MARPLEKUIP
>MENU /MARPLE
>GUIDANCE
MARPLE package control.

>COMMAND MATCH_CONST
>GUIDANCE
set constants for matching
   TYPE = 1 - SVD - Main Tracker matching
   TYPE = 2 - SVD - Outer Tracker matching
   FLAG = 0 - matching use    {x, y, tx, ty, pe }
          1 - matching use    {x, y, tx, ty, pe }
          2 - matching use    {x, y, tx, ty     }
          3 - matching use    {x, y,            }
>ACTION MAALL_READ
>PARAMETER
TYPE         'type of matching'                         I D=1
+
flag         ' type of variable to match'               I D=11110
z_plane      ' plane of matching'                       R D=160 
z_min        ' minimum Z of matching window'            R D=30 
z_max        ' maximum Z of matching window'            R D=500.
pair_cut     ' 0 means NO restriction on N combination' I D=1
n_left       'N allowed combination with left part'     I D=1
n_right      'N allowed combination with right part'    I D=1
delta_x      'delta X'					R D=5.
delta_y      'delta Y'					R D=5.
delta_tx     'delta TX'					R D=0.1
delta_ty     'delta TY'					R D=0.1
delta_pe     'delta PE (Q/p or E )'			R D=1.e+10
chi2         ' the maximum of allowed chi'		R D=300.
delta_cut    '0 means NO restriction on delta is used'  I D=1 


>COMMAND DELTAS_CUT
>GUIDANCE
set constants for delta_cut of matching
   TYPE = 1 - SVD - Main Tracker matching
   TYPE = 2 - SVD - Outer Tracker matching
>ACTION MADELTAS
>PARAMETER
TYPE         'type of matching'                         I D=1
delta_x      'delta X'					R D=5.
delta_y      'delta Y'					R D=5.
delta_tx     'delta TX'					R D=0.1
delta_ty     'delta TY'					R D=0.1
delta_pe     'delta PE (Q/p or E )'			R D=1.e+10
chi2         ' the maximum of allowed chi'		R D=200.
delta_cut    '0 means NO restriction on delta is used' I D=1 


>COMMAND PAIR_CUT
>GUIDANCE
set constants for pair_cut of matching
   TYPE = 1 - SVD - Main Tracker matching
   TYPE = 2 - SVD - Outer Tracker matching
>ACTION MAPAIR_CUT
>PARAMETER
TYPE         'type of matching'                         I D=1
pair_cut   ' 0 means NO restriction on N combination' I D=1
+
n_left     'N allowed combination with left part'     I D=1
n_right    'N allowed combination with right part'    I D=1


>COMMAND CUTS_MATCH
>GUIDANCE
choose cuts for matching
   TYPE = 1 - SVD - Main Tracker matching
   TYPE = 2 - SVD - Outer Tracker matching
>ACTION MACUTS
>PARAMETER
TYPE         'type of matching'                         I D=1
pair_cut     ' 0 means NO restriction on N combination' I D=1
delta_cut    '0 means NO restriction on delta is used'  I D=1 
flag         ' type of variable to match'               I D=11110

>COMMAND SET_CHI2
>GUIDANCE
set chi2 value  for matching
   TYPE = 1 - SVD - Main Tracker matching
   TYPE = 2 - SVD - Outer Tracker matching
>ACTION MACHI2
>PARAMETER
TYPE         'type of matching'                 I D=1
chi2         ' the maximum of allowed chi'	R D=300.


>COMMAND SHOW_MATCH_CONST
>GUIDANCE
show constants used for matching
   TYPE = 1 - SVD - Main Tracker matching
   TYPE = 2 - SVD - Outer Tracker matching
>ACTION MAALL_SHOW
>PARAMETER
TYPE         'type of matching'                         I D=1

