* Author :  Vitaly Eiges,  22.03.99
* Fills the HITB pad hit for a given 
* plane, column and pad number
 
      SUBROUTINE MDBOOKP (iPLANE, iPAD, iCOL)

         IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"

         integer iPLANE, iPAD, iCOL, npmx
         real    xd1,xd2,alsx,xl1,dxpad
         real    yd1,yd2,yref,ys1,ys2,alsy,yl1,yl2
         real    dypd1,dypd2,ywu,ywl
 
#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"

C        Book the new entry in HITB
         call mmbook(jhitb,1)
C         if (flag_first) iq(iqgede_hit1(iPLANE))=iq(jhitb+2)
C                         iq(iqgede_hitL(iPLANE))=iq(jhitb+2)

C        Here follow dgmuoo.F calculations of pad's X,Y and Z

         xd1=fgede_xmin(iPLANE)
         xd2=fgede_xmax(iPLANE)
         alsx=fgede_sxmx(iPLANE)-fgede_sxmn(iPLANE)
         xl1=0.5*(xd2-xd1-alsx)
         dxpad=fgede_xfw(2,iPLANE)

         yd1=fgede_ymin(iPLANE)
         yd2=fgede_ymax(iPLANE)
         if(abs(yd1/(yd2-yd1)).gt.0.7) then
            yref=yd2-yd1        !  bottom
         else
            yref=0.             !  top
         endif
         npmx=igede_nwi(3,iPLANE)
         ys1=fgede_symn(iPLANE)
         ys2=fgede_symx(iPLANE)
         alsy=ys2-ys1
         yl1=(yd2-yd1-alsy)/2.
         yl2=0.01*real(igede_nwi(4,iPLANE))
         dypd1=fgede_xfw(3,iPLANE)   
         dypd2=fgede_xfw(4,iPLANE)   
         if (iPAD.eq.1) then
            ywl=yl1-0.5*yl2
            ywu=yl1+dypd1+0.5*yl2
         else
          ywl=yl1+dypd1+0.5*yl2+(dypd2+yl2)*real(iPAD-2)
          ywu=yl1+dypd1+(dypd2+yl2)*real(iPAD-1)+0.5*yl2
         endif
         if (iPAD.eq.npmx) ywu=yl1+alsy+0.5*yl2

         if (yref.eq.0) then  ! top
            if(iCOL.eq.1) q(qhitb_x_l()) = xd1+xl1+0.5*dxpad-0.4 ! -4mm
            if(iCOL.eq.2) q(qhitb_x_l()) = xd2-xl1-0.5*dxpad-0.4 ! -4mm
         endif
         if (yref.ne.0) then  ! bottom
            if(iCOL.eq.1) q(qhitb_x_l()) = xd1+xl1+0.5*dxpad+0.4 ! +4mm
            if(iCOL.eq.2) q(qhitb_x_l()) = xd2-xl1-0.5*dxpad+0.4 ! +4mm
         endif

         if(yref.eq.0) q(qhitb_y_l()) = yd1+0.5*(ywl+ywu)
         if(yref.ne.0) q(qhitb_y_l()) = yd2-0.5*(ywl+ywu)

         q(qhitb_z_l()) = fgede_zfw(2,iPLANE) + 1 ! +1cm
       iq(iqhitb_gede_l()) = iPLANE

         q(qhitb_q_l()) = dxpad+0.8 ! +8mm
         if (iPAD.eq.1) q(qhitb_r_l()) = dypd1
         if (iPAD.ne.1) q(qhitb_r_l()) = dypd2

CC         print*,'mdbookp plane, pad,  hit = ',iPLANE, iPAD, iq(jhitb+2) 

 900  END
