
      subroutine diring(sl_rich)

*     **** display RICH hits
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"
#include "pris/zmh.fi"

      integer       sl_rich,gede_rich,i
      integer       gede,hb,hb1,hb2,rc,rc1,rc2
      real*4        phi,lam,rad1,rad2,xxx(4),yyy(4),size,rsize
      logical       trmcor
      integer       tumchit,imc

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RSEG.ff"



      i=pgesl_gede(sl_rich)
 30   if (i.ne.0) then
         gede_rich=mgesl_gede(i)
         i=xgesl_gede(i)
         goto 30
      endif

*     ***
*     ***    plot photons hits
      if (lwirezg) then
         hb1=igede_hit1(gede_rich)
         hb2=igede_hitl(gede_rich)
         if (hb2.eq.0) then
            hb2=-1
         endif
         do 10 hb=hb1,hb2

*           **** check associated MC particle
            if (mczg.ne.0) then
*              **** discard if no match with MC particle
               if (.not.trmcor(hb,mczg)) go to 10
            endif
            if (lb0zg) then       ! check B0 option
               imc = tumchit(hb)
               if (imc.le.0) go to 10
               if (.not.gold_mh(imc)) go to 10
            endif


            
            phi=fhitb_q(hb)*1000 ! horizontal angle (mrad)
            lam=fhitb_r(hb)*1000 ! vertical angle (mrad)
            size=0.75

            xxx(1)=phi-size
            yyy(1)=lam-size
            xxx(2)=phi-size
            yyy(2)=lam+size
            xxx(4)=phi+size
            yyy(4)=lam-size
            xxx(3)=phi+size
            yyy(3)=lam+size
            call igset('FAIS',1.)
            call igset('FACI',cowirzg)
            call ifa(4,xxx,yyy) ! draw hit
         
 10      continue
      endif

      
*     ***
*     ***    plot reconstructed tracks
      if (lrsegzg.and.jrseg.gt.0) then
         rc1=1
         rc2=nrseg()
         do 40 rc=rc1,rc2
            if (irseg_cmp(rc).ne.rsegc_rich) go to 40
            call igset('FAIS',1.)
            call igset('BORD',0.)
            call igset('FACI',corczg)
         
            phi=frseg_xf(rc)*1000
            lam=frseg_yf(rc)*1000
            rsize=.25 
            rad1=frseg_time(rc)*1000-rsize
            rad2=rad1+2*rsize
            call igarc(phi,lam,rad1,rad2,0.,0.) ! draw ring
            
            size=1.5
            call igarc(phi,lam,0,size,0.,0.) ! draw center
 40      continue
      endif

      end

