*-- Author :    A.Spiridonov   08/09/98

      subroutine tftcweed()

*     **** weedout all but the best candidates in tf
      implicit none

#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
      integer index_al(ncamx), nal, ii
      real quality_min

#include "rang/descend.fi"
*---------------------------------------------------------
*     **** loop over itf, select alive candidates
      nal = 0
      do ii=begin_ft,nca_ft
       if (alive_ft(ii)) then
        nal = nal + 1
        index_al(nal) = ii
       endif
      enddo

*     **** sort descending quality
      call sortzv(quality_ft,index_al,nal,+1,+1,+1)

#ifdef TC_TEST
*     **** print candidate
      print '("tftcweed : <<<<< canditates ",i4," >>>>>")',nal
      if(nal.ge.1) then 
        do ii=1,min0(rmax_TC_zfpar,nal) 
          call tfprhz(index_al(ii))
        end do
      end if
#endif
 
*     **** best candidate sets standard
      quality_min = quality_ft(index_al(1)) - 1.

*     **** kill everything below quality_min
      do ii=2,min0(rmax_TC_zfpar,nal)
       if (quality_ft(index_al(ii)).lt.quality_min)
     +                           alive_ft(index_al(ii)) = .false.
      enddo

*     **** kill everything but the best candidates
      do ii=rmax_TC_zfpar+1,nal
       alive_ft(index_al(ii)) = .false.
      enddo

*#ifdef TC_TEST
*      **** kill predecessors of the best candidates
       do ii=1,min0(rmax_TC_zfpar,nal)
         if( alive_ft( ift_preced(index_al(ii)) ) ) then
           alive_ft( ift_preced(index_al(ii) ) ) = .false.   
         end if
       end do
*#endif

      end
