// ********************************************************************
//
//  Routine:      rc99AVDS
//
//  Description:  silicon stand alone reconstruction
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "silarte/silarte.hh"

//int  SvdEvnt();
//void HolmesEvent();

void makeRtra();

//*****************************************************************
// function
//*****************************************************************

int rc99AVDS(int level) {

//==================================================================
// 1. create hits for data
//==================================================================

     int flag = 0;
     if (level ==1 || level ==3 ){
        if (ArteTable<MTRA>::begin() == ArteTable<MTRA>::end()) 
         flag = SvdEvnt();
     };

//==================================================================
// 2. reconstruction
//==================================================================

     if ( level > 1 ) HolmesEvent();

//==================================================================
// 3. refit tracks with ranger and fill RTRA banks
//==================================================================

     //     makeRtra();

     return flag;
}
