*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
*-- changed:   A.Spiridonov  14/05/98
c
c-------------------------------------------------------------
c
c       subroutine:   VTZERO
c
c       input:    none
c
c       output:   none
c
c       action:   resets all pointers for general initialization
c
c-------------------------------------------------------------
c
      subroutine  VTZERO

      implicit none

      integer i, j

#include "vt/vtdat.fi"

      do  i = 1, nvtmax
        vtset(i) = .false.
        ntr(i) = 0
        nconst(i) = 0
        do  j = 1, ntrk
          ktr(i,j) = 0
        enddo
      enddo
      do  i = 1, ntrtot
        invflg(i) = 0
        nv(i) = 0
        do  j = 1, nvttrk
          kv(i,j) = 0
        enddo
      enddo
      do  i = 1, ntrtot
        do  j = 1, nvtmax
          jv(j,i) = 0
        enddo
      enddo

      nvt = 0

      trmult = 0                         !  by AS

      return
      end
